diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index 57433468e..240f39051 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -652,481 +628,397 @@ public class World implements WorldSource {
         return true;
     }
 
-    public boolean isChunkLoaded(int x, int z)
-    {
-        return chunkProvider.isChunkLoaded(x, z);
+    @Deprecated
+    public final boolean areBlocksLoaded(final int minX, final int minY, final int minZ, final int maxX, final int maxY, final int maxZ) {
+        return this.areBlocksLoaded(new TilePos(minX, minY, minZ), new TilePos(maxX, maxY, maxZ));
     }
 
-    public Chunk getChunkFromBlockCoords(int x, int z)
-    {
-        return getChunkFromChunkCoords(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z));
+    public boolean isChunkLoaded(final @NotNull ChunkPos chunkPos) {
+        return this.chunkProvider.isChunkLoaded(chunkPos.x, chunkPos.z);
     }
 
-    public Chunk getChunkFromChunkCoords(int x, int z)
-    {
-        return chunkProvider.provideChunk(x, z);
+    @Deprecated
+    public final boolean isChunkLoaded(final int x, final int z) {
+        return this.isChunkLoaded(new ChunkPos(x, z));
     }
 
-    public boolean setBlockAndMetadata(int x, int y, int z, int id, int meta)
-    {
-        if(x < MIN_BLOCK_X || z < MIN_BLOCK_Z || x >= MAX_BLOCK_X || z > MAX_BLOCK_Z)
-        {
-            return false;
-        }
-        if(y < 0)
-        {
-            return false;
-        }
-        if(y >= getHeightBlocks())
-        {
-            return false;
-        } else
-        {
-            Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z));
-            return chunk.setBlockIDWithMetadata(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1), id, meta);
-        }
+    public @NotNull Chunk getChunk(final @NotNull TilePos tilePos) {
+        return this.getChunk(tilePos.toChunkPos());
     }
 
-    public boolean setBlockRaw(int x, int y, int z, int id) {
-        return setBlockAndMetadataRaw(x, y, z, id, getBlockMetadata(x, y, z));
+    @Deprecated
+    public final @NotNull Chunk getChunkFromBlockCoords(final int x, final int z) {
+        return this.getChunk(new TilePos(x, 0, z));
     }
-    public boolean setBlockAndMetadataRaw(int x, int y, int z, int id, int meta)
-    {
-        if(x < MIN_BLOCK_X || z < MIN_BLOCK_Z || x >= MAX_BLOCK_X || z > MAX_BLOCK_Z)
-        {
-            return false;
-        }
-        if(y < 0)
-        {
-            return false;
-        }
-        if(y >= getHeightBlocks())
-        {
-            return false;
-        } else
-        {
-            Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z));
-            return chunk.setBlockIDWithMetadataRaw(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1), id, meta);
-        }
+
+    public @NotNull Chunk getChunk(final @NotNull ChunkPos chunkPos) {
+        return this.chunkProvider.provideChunk(chunkPos.x, chunkPos.z);
     }
 
-    public boolean setBlock(int x, int y, int z, int id)
-    {
-        if(x < MIN_BLOCK_X || z < MIN_BLOCK_Z || x >= MAX_BLOCK_X || z > MAX_BLOCK_Z)
-        {
+    @Deprecated
+    public final @NotNull Chunk getChunkFromChunkCoords(final int x, final int z) {
+        return this.getChunk(new ChunkPos(x, z));
+    }
+
+    @Override
+    public boolean setBlockIdData(final @NotNull TilePos tilePos, final int id, final int data) {
+        if (!tilePos.inBounds(this)) {
             return false;
+        } else {
+            return this.getChunk(tilePos).setBlockIdData(tilePos.toChunkTilePos(), id, data);
         }
-        if(y < 0)
-        {
+    }
+
+    public boolean setBlockIdRaw(final @NotNull TilePos tilePos, final int id) {
+        return this.setBlockIdDataRaw(tilePos, id, this.getBlockData(tilePos));
+    }
+
+    @Deprecated
+    public final boolean setBlockRaw(final int x, final int y, final int z, final int id) {
+        return this.setBlockIdRaw(new TilePos(x, y, z), id);
+    }
+
+    public boolean setBlockIdDataRaw(final @NotNull TilePos tilePos, final int id, final int data) {
+        if (!tilePos.inBounds(this)) {
             return false;
+        } else {
+            return this.getChunk(tilePos).setBlockIdDataRaw(tilePos.toChunkTilePos(), id, data);
         }
-        if(y >= getHeightBlocks())
-        {
+    }
+
+    @Deprecated
+    public final boolean setBlockAndMetadataRaw(final int x, final int y, final int z, final int id, final int metadata) {
+        return this.setBlockIdDataRaw(new TilePos(x, y, z), id, metadata);
+    }
+
+    @Override
+    public boolean setBlockId(@NotNull final TilePos tilePos, final int id) {
+        if (!tilePos.inBounds(this)) {
             return false;
-        } else
-        {
-            Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z));
-            return chunk.setBlockID(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1), id);
+        } else {
+            return this.getChunk(tilePos).setBlockId(tilePos.toChunkTilePos(), id);
         }
     }
 
     @Override
-    public Material getBlockMaterial(int x, int y, int z)
-    {
-        int l = getBlockId(x, y, z);
-        if(l == 0)
-        {
+    public @NotNull Material getBlockMaterial(@NotNull final TilePos tilePos) {
+        final @Nullable Block<?> block = this.getBlock(tilePos);
+        if (block == null) {
             return Material.air;
-        } else
-        {
-            return Blocks.blocksList[l].getMaterial();
+        } else {
+            return block.getMaterial();
         }
     }
 
     @Override
-    public int getBlockMetadata(int x, int y, int z)
-    {
-        if(x < MIN_BLOCK_X || z < MIN_BLOCK_Z || x >= MAX_BLOCK_X || z > MAX_BLOCK_Z)
-        {
-            return 0;
-        }
-        if(y < 0)
-        {
-            return 0;
-        }
-        if(y >= getHeightBlocks())
-        {
+    public int getBlockData(final @NotNull TilePos tilePos) {
+        if (!tilePos.inBounds(this)) {
             return 0;
-        } else
-        {
-            Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z));
-            x &= (Chunk.CHUNK_SIZE_X - 1);
-            z &= (Chunk.CHUNK_SIZE_Z - 1);
-            return chunk.getBlockMetadata(x, y, z);
+        } else {
+            return this.getChunk(tilePos).getBlockData(tilePos.toChunkTilePos());
         }
     }
 
-    public void setBlockMetadataWithNotify(int x, int y, int z, int meta)
-    {
-        if(setBlockMetadata(x, y, z, meta))
-        {
-            markBlockNeedsUpdate(x, y, z);
-            int id = getBlockId(x, y, z);
-            // TODO The name neighborNotifyOnMetadataChangeDisabled suggests that this should be inverted, but doing that breaks redstone
-            if(Blocks.neighborNotifyOnMetadataChangeDisabled[id & 0x3fff])
-            {
-                notifyBlocksOfNeighborChange(x, y, z, id);
+    public boolean setBlockDataNotify(final @NotNull TilePos tilePos, final int data) {
+        if (this.setBlockData(tilePos, data)) {
+            this.markBlockNeedsUpdate(tilePos);
+
+            final int id = this.getBlockId(tilePos);
+            if (Blocks.neighborNotifyOnMetadataChangeDisabled[id & 0x3FFF]) {
+                this.notifyBlocksOfNeighborChange(tilePos, id);
+                return true;
             }
         }
+
+        return false;
     }
 
-    public boolean setBlockMetadata(int x, int y, int z, int meta)
-    {
-        if(x < MIN_BLOCK_X || z < MIN_BLOCK_Z || x >= MAX_BLOCK_X || z > MAX_BLOCK_Z)
-        {
-            return false;
-        }
-        if(y < 0)
-        {
-            return false;
-        }
-        if(y >= getHeightBlocks())
-        {
+    @Deprecated
+    public final void setBlockMetadataWithNotify(final int x, final int y, final int z, final int data) {
+        this.setBlockDataNotify(new TilePos(x, y, z), data);
+    }
+
+    @Override
+    public boolean setBlockData(final @NotNull TilePos tilePos, final int data) {
+        if (!tilePos.inBounds(this)) {
             return false;
-        } else
-        {
-            Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z));
-            x &= (Chunk.CHUNK_SIZE_X - 1);
-            z &= (Chunk.CHUNK_SIZE_Z - 1);
-            chunk.setBlockMetadata(x, y, z, meta);
+        } else {
+            this.getChunk(tilePos).setBlockData(tilePos.toChunkTilePos(), data);
             return true;
         }
     }
 
-    public boolean setBlockWithNotify(int x, int y, int z, int id)
-    {
-        if(setBlock(x, y, z, id))
-        {
-            notifyBlockChange(x, y, z, id);
+    public boolean setBlockIdNotify(final @NotNull TilePos tilePos, final int id) {
+        if (this.setBlockId(tilePos, id)) {
+            this.notifyBlockChange(tilePos, id);
             return true;
-        } else
-        {
-            return false;
         }
+
+        return false;
     }
 
-    public boolean setBlockAndMetadataWithNotify(int x, int y, int z, int id, int meta)
-    {
-        if(setBlockAndMetadata(x, y, z, id, meta))
-        {
-            notifyBlockChange(x, y, z, id);
+    @Deprecated
+    public final boolean setBlockWithNotify(final int x, final int y, final int z, final int id) {
+        return this.setBlockIdNotify(new TilePos(x, y, z), id);
+    }
+
+    public boolean setBlockIdDataNotify(final @NotNull TilePos tilePos, final int id, final int data) {
+        if (this.setBlockIdData(tilePos, id, data)) {
+            this.notifyBlockChange(tilePos, id);
             return true;
-        } else
-        {
-            return false;
         }
+
+        return false;
     }
 
-    public void markBlockNeedsUpdate(int x, int y, int z)
-    {
-        for (LevelListener listener : listeners)
-        {
-            listener.blockChanged(x, y, z);
+    @Deprecated
+    public final boolean setBlockAndMetadataWithNotify(final int x, final int y, final int z, final int id, final int data) {
+        return this.setBlockIdDataNotify(new TilePos(x, y, z), id, data);
+    }
+
+    public void markBlockNeedsUpdate(final @NotNull TilePos tilePos) {
+        for (final @NotNull LevelListener listener : this.listeners) {
+            listener.blockChanged(tilePos.x, tilePos.y, tilePos.z);
         }
     }
 
-    public void notifyBlockChange(int x, int y, int z, int id)
-    {
-        markBlockNeedsUpdate(x, y, z);
-        notifyBlocksOfNeighborChange(x, y, z, id);
+    @Deprecated
+    public final void markBlockNeedsUpdate(final int x, final int y, final int z) {
+        this.markBlockNeedsUpdate(new TilePos(x, y, z));
     }
 
-    public void markBlocksDirtyVertical(int x, int z, int y0, int y1)
-    {
-        if(y0 > y1)
-        {
-            int t = y1;
-            y1 = y0;
-            y0 = t;
-        }
-        markBlocksDirty(x, y0, z, x, y1, z);
+    public void notifyBlockChange(final @NotNull TilePos tilePos, final int id) {
+        this.markBlockNeedsUpdate(tilePos);
+        this.notifyBlocksOfNeighborChange(tilePos, id);
     }
 
-    public void markBlockDirty(int x, int y, int z)
-    {
-        for (LevelListener listener : listeners)
-        {
-            listener.setBlocksDirty(x, y, z, x, y, z);
+    @Deprecated
+    public final void notifyBlockChange(final int x, final int y, final int z, final int id) {
+        this.notifyBlockChange(new TilePos(x, y, z), id);
+    }
+
+    public void markBlocksDirtyVertical(final int x, final int z, final int y0, final int y1) {
+        this.markBlocksDirty(new TilePos(x, Math.min(y0, y1), z), new TilePos(x, Math.max(y0, y1), z));
+    }
+
+    public void markBlockDirty(final @NotNull TilePos tilePos) {
+        for (final @NotNull LevelListener listener : this.listeners) {
+            listener.setBlocksDirty(tilePos.x, tilePos.y, tilePos.z, tilePos.x, tilePos.y, tilePos.z);
         }
     }
 
-    public void markBlocksDirty(int minX, int minY, int minZ, int maxX, int maxY, int maxZ)
-    {
-        for (LevelListener listener : listeners)
-        {
-            listener.setBlocksDirty(minX, minY, minZ, maxX, maxY, maxZ);
+    @Deprecated
+    public final void markBlockDirty(final int x, final int y, final int z) {
+        this.markBlockDirty(new TilePos(x, y, z));
+    }
+
+    public void markBlocksDirty(final @NotNull TilePos min, final @NotNull TilePos max) {
+        for (final @NotNull LevelListener listener : this.listeners) {
+            listener.setBlocksDirty(
+                Math.min(min.x, max.x),
+                Math.min(min.y, max.y),
+                Math.min(min.z, max.z),
+                Math.max(min.x, max.x),
+                Math.max(min.y, max.y),
+                Math.max(min.z, max.z)
+            );
         }
     }
 
-    public void notifyBlocksOfNeighborChange(int x, int y, int z, int blockId)
-    {
-        notifyBlockOfNeighborChange(x - 1, y, z, blockId);
-        notifyBlockOfNeighborChange(x + 1, y, z, blockId);
-        notifyBlockOfNeighborChange(x, y - 1, z, blockId);
-        notifyBlockOfNeighborChange(x, y + 1, z, blockId);
-        notifyBlockOfNeighborChange(x, y, z - 1, blockId);
-        notifyBlockOfNeighborChange(x, y, z + 1, blockId);
+    @Deprecated
+    public final void markBlocksDirty(final int minX, final int minY, final int minZ, final int maxX, final int maxY, final int maxZ) {
+        this.markBlocksDirty(new TilePos(minX, minY, minZ), new TilePos(maxX, maxY, maxZ));
     }
 
-    private void notifyBlockOfNeighborChange(int x, int y, int z, int blockId)
-    {
-        if(noNeighborUpdate || isClientSide)
-        {
+    public void notifyBlocksOfNeighborChange(final @NotNull TilePos tilePos, final int id) {
+        this.notifyBlockOfNeighborChange(tilePos.west(), id);
+        this.notifyBlockOfNeighborChange(tilePos.east(), id);
+        this.notifyBlockOfNeighborChange(tilePos.down(), id);
+        this.notifyBlockOfNeighborChange(tilePos.up(), id);
+        this.notifyBlockOfNeighborChange(tilePos.north(), id);
+        this.notifyBlockOfNeighborChange(tilePos.south(), id);
+    }
+
+    @Deprecated
+    public final void notifyBlocksOfNeighborChange(final int x, final int y, final int z, final int id) {
+        this.notifyBlocksOfNeighborChange(new TilePos(x, y, z), id);
+    }
+
+    private void notifyBlockOfNeighborChange(final @NotNull TilePos tilePos, final int id) {
+        if (this.noNeighborUpdate || this.isClientSide) {
             return;
         }
-        Block<?> block = Blocks.blocksList[getBlockId(x, y, z)];
-        if(block != null)
-        {
-            block.onNeighborBlockChange(this, x, y, z, blockId);
+        final @Nullable Block<?> block = this.getBlock(tilePos);
+        if (block != null) {
+            block.onNeighborBlockChange(this, tilePos.x, tilePos.y, tilePos.z, id);
         }
     }
 
-    public boolean canBlockSeeTheSky(int x, int y, int z)
-    {
-        return getChunkFromChunkCoords(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z)).canBlockSeeTheSky(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1));
+    public boolean canBlockSeeSky(final @NotNull TilePos tilePos) {
+        return this.getChunk(tilePos).canBlockSeeSky(tilePos.toChunkTilePos());
     }
 
-    public int getFullBlockLightValue(int x, int y, int z)
-    {
-        if(y < 0)
-        {
+    @Deprecated
+    public final boolean canBlockSeeTheSky(final int x, final int y, final int z) {
+        return this.canBlockSeeSky(new TilePos(x, y, z));
+    }
+
+    public int getFullBlockLightValue(final @NotNull TilePos tilePos) {
+        if (tilePos.y < 0) {
             return 0;
+        } else {
+            return this.getChunk(tilePos).getRawBrightness(new TilePos(tilePos.x, Math.min(tilePos.y, this.getHeightBlocks() - 1), tilePos.z).toChunkTilePos(), 0);
         }
-        if(y >= getHeightBlocks())
-        {
-            y = getHeightBlocks() - 1;
-        }
-        return getChunkFromChunkCoords(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z)).getRawBrightness(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1), 0);
     }
 
-    public int getBlockLightValue(int x, int y, int z)
-    {
-        return getBlockLightValue_do(x, y, z, true);
+    @Deprecated
+    public final int getFullBlockLightValue(final int x, final int y, final int z) {
+        return this.getFullBlockLightValue(new TilePos(x, y, z));
     }
 
-    public int getBlockLightValue_do(int x, int y, int z, boolean first)
-    {
-        if(x < MIN_BLOCK_X || z < MIN_BLOCK_Z || x >= MAX_BLOCK_X || z > MAX_BLOCK_Z)
-        {
+    public int getBlockLightValue(final @NotNull TilePos tilePos) {
+        return this.getBlockLightValue_do(tilePos, true);
+    }
+
+    @Deprecated
+    public final int getBlockLightValue(final int x, final int y, final int z) {
+        return this.getBlockLightValue(new TilePos(x, y, z));
+    }
+
+    private int getBlockLightValue_do(final @NotNull TilePos tilePos, final boolean first) {
+        if (tilePos.x < MIN_BLOCK_X || tilePos.z < MIN_BLOCK_Z || tilePos.x > MAX_BLOCK_X || tilePos.z > MAX_BLOCK_Z) {
             return MAX_BRIGHTNESS;
         }
-        if(first)
-        {
-            if(getBlockLitInteriorSurface(x, y, z))
-            {
-                int i1 = getBlockLightValue_do(x, y + 1, z, false);
-                int j1 = getBlockLightValue_do(x + 1, y, z, false);
-                int k1 = getBlockLightValue_do(x - 1, y, z, false);
-                int l1 = getBlockLightValue_do(x, y, z + 1, false);
-                int i2 = getBlockLightValue_do(x, y, z - 1, false);
-                if(j1 > i1)
-                {
-                    i1 = j1;
-                }
-                if(k1 > i1)
-                {
-                    i1 = k1;
-                }
-                if(l1 > i1)
-                {
-                    i1 = l1;
-                }
-                if(i2 > i1)
-                {
-                    i1 = i2;
-                }
-                return i1;
+
+        if (first) {
+            if (this.getBlockLitInteriorSurface(tilePos)) {
+                final int lightUp = this.getBlockLightValue_do(tilePos.up(), false);
+                final int lightEast = this.getBlockLightValue_do(tilePos.east(), false);
+                final int lightWest = this.getBlockLightValue_do(tilePos.west(), false);
+                final int lightSouth = this.getBlockLightValue_do(tilePos.south(), false);
+                final int lightNorth = this.getBlockLightValue_do(tilePos.north(), false);
+                return Math.max(lightUp, Math.max(lightEast, Math.max(lightWest, Math.max(lightSouth, lightNorth))));
             }
         }
-        if(y < 0)
-        {
+
+        if (tilePos.y < 0) {
             return 0;
         }
-        if(y >= getHeightBlocks())
-        {
-            y = getHeightBlocks() - 1;
-        }
-        Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z));
-        x &= (Chunk.CHUNK_SIZE_X - 1);
-        z &= (Chunk.CHUNK_SIZE_Z - 1);
-        return chunk.getRawBrightness(x, y, z, skyDarken);
+        return this.getChunk(tilePos).getRawBrightness(new TilePos(tilePos.x, Math.min(tilePos.y, this.getHeightBlocks() - 1), tilePos.z).toChunkTilePos(), this.skyDarken);
     }
 
-    public boolean canExistingBlockSeeTheSky(int x, int y, int z)
-    {
-        if(x < MIN_BLOCK_X || z < MIN_BLOCK_Z || x >= MAX_BLOCK_X || z > MAX_BLOCK_Z)
-        {
-            return false;
-        }
-        if(y < 0)
-        {
-            return false;
-        }
-        if(y >= getHeightBlocks())
-        {
+    public boolean canLoadedBlockSeeSky(final @NotNull TilePos tilePos) {
+        if (tilePos.y >= this.getHeightBlocks()) {
             return true;
-        }
-        if(!isChunkLoaded(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z)))
-        {
+        } else if (!tilePos.inBounds(this)) {
+            return false;
+        } else if (!this.isBlockLoaded(tilePos)) {
             return false;
-        } else
-        {
-            Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z));
-            x &= (Chunk.CHUNK_SIZE_X - 1);
-            z &= (Chunk.CHUNK_SIZE_Z - 1);
-            return chunk.canBlockSeeTheSky(x, y, z);
         }
+
+        return this.getChunk(tilePos).canBlockSeeSky(tilePos.toChunkTilePos());
     }
 
-    public int getHeightValue(int x, int z)
-    {
-        if(x < World.MIN_BLOCK_X || z < World.MIN_BLOCK_Z || x >= World.MAX_BLOCK_X || z > World.MAX_BLOCK_Z)
-        {
+    @Deprecated
+    public final boolean canExistingBlockSeeTheSky(final int x, final int y, final int z) {
+        return this.canLoadedBlockSeeSky(new TilePos(x, y, z));
+    }
+
+    public int getHeightValue(final int x, final int z) {
+        if (x < World.MIN_BLOCK_X || z < World.MIN_BLOCK_Z || x > World.MAX_BLOCK_X || z > World.MAX_BLOCK_Z) {
             return 0;
         }
-        if(!isChunkLoaded(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z)))
-        {
+        final @NotNull TilePos tilePos = new TilePos(x, 0, z);
+
+        if (!this.isBlockLoaded(new TilePos(x, 0, z))) {
             return 0;
-        }
-        else
-        {
-            Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z));
-            return chunk.getHeightValue(x & (Chunk.CHUNK_SIZE_X - 1), z & (Chunk.CHUNK_SIZE_Z - 1));
+        } else {
+            return this.getChunk(tilePos).getHeightValue(x & (Chunk.CHUNK_SIZE_X - 1), z & (Chunk.CHUNK_SIZE_Z - 1));
         }
     }
 
     @Override
-    public int getSavedLightValue(LightLayer layer, int x, int y, int z)
-    {
-        if(y < 0)
-        {
-            y = 0;
-        }
-        if(y >= getHeightBlocks())
-        {
-            y = getHeightBlocks() - 1;
-        }
-        if(y < 0 || y >= getHeightBlocks() || x < MIN_BLOCK_X || z < MIN_BLOCK_Z || x >= MAX_BLOCK_X || z > MAX_BLOCK_Z)
-        {
-            return layer.defaultLightLevel;
-        }
-        int l = Math.floorDiv(x, Chunk.CHUNK_SIZE_X);
-        int i1 = Math.floorDiv(z, Chunk.CHUNK_SIZE_Z);
-        if(!isChunkLoaded(l, i1))
-        {
+    public int getSavedLightValue(final @NotNull LightLayer lightLayer, final @NotNull TilePos tilePos) {
+        if (!tilePos.inBounds(this)) {
+            return lightLayer.defaultLightLevel;
+        } else if (!this.isBlockLoaded(tilePos)) {
             return 0;
-        }
-        else
-        {
-            Chunk chunk = getChunkFromChunkCoords(l, i1);
-            return chunk.getBrightness(layer, x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1));
+        } else {
+            return this.getChunk(tilePos).getBrightness(lightLayer, tilePos.toChunkTilePos());
         }
     }
 
     @Override
     public boolean isRetro() {
-        return worldType.isRetro();
+        return this.worldType.isRetro();
     }
 
-    public void setLightValue(LightLayer layer, int x, int y, int z, int value)
-    {
-        if(x < MIN_BLOCK_X || z < MIN_BLOCK_Z || x >= MAX_BLOCK_X || z > MAX_BLOCK_Z)
-        {
-            return;
-        }
-        if(y < 0)
-        {
-            return;
-        }
-        if(y >= getHeightBlocks())
-        {
-            return;
-        }
-        if(!isChunkLoaded(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z)))
-        {
-            return;
-        }
-        Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z));
-        chunk.setBrightness(layer, x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1), value);
-        for (LevelListener listener : listeners)
-        {
-            listener.blockChanged(x, y, z);
+    @Override
+    public void setLightValue(final @NotNull LightLayer lightLayer, final @NotNull TilePos tilePos, final int value) {
+        if (tilePos.inBounds(this) && this.isBlockLoaded(tilePos)) {
+            this.getChunk(tilePos).setBrightness(lightLayer, tilePos.toChunkTilePos(), value);
+            for (final @NotNull LevelListener listener : this.listeners) {
+                listener.blockChanged(tilePos.x, tilePos.y, tilePos.z);
+            }
         }
     }
 
-	@Override
-	public float getBrightness(int x, int y, int z, int blockLightValue) {
-		int i1 = getBlockLightValue(x, y, z);
-		if(i1 < blockLightValue) {
-			i1 = blockLightValue;
-		}
-		return worldType.getBrightnessRamp()[i1];
-	}
-    
     @Override
-    public int getLightmapCoord(int x, int y, int z, int blockLightValue) {
-        int skyLight = getSavedLightValue(LightLayer.Sky, x, y, z);
-        int blockLight = Math.max(getSavedLightValue(LightLayer.Block, x, y, z), blockLightValue);
+    public float getBrightness(final @NotNull TilePos tilePos, final int lightEmission) {
+        final int lightValue = this.getBlockLightValue(tilePos);
+        return this.worldType.getBrightnessRamp()[Math.max(lightValue, lightEmission)];
+    }
+
+    @Override
+    public int getLightmapCoord(final @NotNull TilePos tilePos, final int lightEmission) {
+        int skyLight = this.getSavedLightValue(LightLayer.Sky, tilePos);
+        int blockLight = Math.max(this.getSavedLightValue(LightLayer.Block, tilePos), lightEmission);
 
-        if(getBlockLitInteriorSurface(x, y, z)) {
-            skyLight = Math.max(skyLight, getSavedLightValue(LightLayer.Sky, x, y + 1, z));
-            skyLight = Math.max(skyLight, getSavedLightValue(LightLayer.Sky, x, y - 1, z));
-            skyLight = Math.max(skyLight, getSavedLightValue(LightLayer.Sky, x + 1, y, z));
-            skyLight = Math.max(skyLight, getSavedLightValue(LightLayer.Sky, x - 1, y, z));
-            skyLight = Math.max(skyLight, getSavedLightValue(LightLayer.Sky, x, y, z + 1));
-            skyLight = Math.max(skyLight, getSavedLightValue(LightLayer.Sky, x, y, z - 1));
+        if (this.getBlockLitInteriorSurface(tilePos)) {
+            skyLight = Math.max(skyLight, this.getSavedLightValue(LightLayer.Sky, tilePos.up()));
+            skyLight = Math.max(skyLight, this.getSavedLightValue(LightLayer.Sky, tilePos.down()));
+            skyLight = Math.max(skyLight, this.getSavedLightValue(LightLayer.Sky, tilePos.east()));
+            skyLight = Math.max(skyLight, this.getSavedLightValue(LightLayer.Sky, tilePos.west()));
+            skyLight = Math.max(skyLight, this.getSavedLightValue(LightLayer.Sky, tilePos.south()));
+            skyLight = Math.max(skyLight, this.getSavedLightValue(LightLayer.Sky, tilePos.north()));
 
-            blockLight = Math.max(blockLight, getSavedLightValue(LightLayer.Block, x, y + 1, z));
-            blockLight = Math.max(blockLight, getSavedLightValue(LightLayer.Block, x, y - 1, z));
-            blockLight = Math.max(blockLight, getSavedLightValue(LightLayer.Block, x + 1, y, z));
-            blockLight = Math.max(blockLight, getSavedLightValue(LightLayer.Block, x - 1, y, z));
-            blockLight = Math.max(blockLight, getSavedLightValue(LightLayer.Block, x, y, z + 1));
-            blockLight = Math.max(blockLight, getSavedLightValue(LightLayer.Block, x, y, z - 1));
+            blockLight = Math.max(blockLight, this.getSavedLightValue(LightLayer.Block, tilePos.up()));
+            blockLight = Math.max(blockLight, this.getSavedLightValue(LightLayer.Block, tilePos.down()));
+            blockLight = Math.max(blockLight, this.getSavedLightValue(LightLayer.Block, tilePos.east()));
+            blockLight = Math.max(blockLight, this.getSavedLightValue(LightLayer.Block, tilePos.west()));
+            blockLight = Math.max(blockLight, this.getSavedLightValue(LightLayer.Block, tilePos.south()));
+            blockLight = Math.max(blockLight, this.getSavedLightValue(LightLayer.Block, tilePos.north()));
         }
 
-        return getLightmapCoord(skyLight, blockLight);
+        return this.getLightmapCoord(skyLight, blockLight);
     }
 
     @Override
-    public int getLightmapCoord(int skylight, int blocklight) {
+    public int getLightmapCoord(final int skyLight, final int blockLight) {
         return 0; // TODO figure out if/how we would get this working in core
     }
 
     @Override
-    public float getLightBrightness(int x, int y, int z)
-    {
-        return worldType.getBrightnessRamp()[getBlockLightValue(x, y, z)];
+    public float getLightBrightness(final @NotNull TilePos tilePos) {
+        return this.worldType.getBrightnessRamp()[this.getBlockLightValue(tilePos)];
     }
 
-    public boolean isDaytime()
-    {
-        return skyDarken < 4;
+    public boolean isDaytime() {
+        return this.skyDarken < 4;
     }
 
-    @Nullable
-    public HitResult checkBlockCollisionBetweenPoints(Vec3 start, Vec3 end)
+    public @Nullable HitResult checkBlockCollisionBetweenPoints(Vec3 start, Vec3 end)
     {
         return checkBlockCollisionBetweenPoints(start, end, false, false, false);
     }
 
-    @Nullable
-    public HitResult checkBlockCollisionBetweenPoints(Vec3 start, Vec3 end, boolean shouldCollideWithFluids)
+
+    public @Nullable HitResult checkBlockCollisionBetweenPoints(Vec3 start, Vec3 end, boolean shouldCollideWithFluids)
     {
         return checkBlockCollisionBetweenPoints(start, end, shouldCollideWithFluids, false, false);
     }
 
-    @Nullable
-    public HitResult checkBlockCollisionBetweenPoints(Vec3 start, Vec3 end, boolean shouldCollideWithFluids, boolean ignoreNonColliderBlocks, boolean useSelectorBoxes)
+    public @Nullable HitResult checkBlockCollisionBetweenPoints(Vec3 start, Vec3 end, boolean shouldCollideWithFluids, boolean ignoreNonColliderBlocks, boolean useSelectorBoxes)
     {
         if(Double.isNaN(start.x) || Double.isNaN(start.y) || Double.isNaN(start.z))
         {
